<!--
 Copyright © VNG Realisatie 2024
 Licensed under the EUPL
-->

{{ define "content" }}
    <script>
        document.body.addEventListener("htmx:beforeSwap", function (evt) {
            if (
                evt.detail.xhr.status === 400 ||
                evt.detail.xhr.status === 500
            ) {
                evt.detail.shouldSwap = true;
                evt.detail.isError = false;
            }
        });
    </script>

    <div class="publish-service-page">
        <p>
            {{ if .Form.Name }}
                <a href="/services/{{ .Form.Name }}" class="button--link"
                    >{{ svg "icon-chevron-left" "icon--inline" }}
                    {{ i18n "Back" }}</a
                >
            {{ else }}
                <a href="/services/publications" class="button--link"
                    >{{ svg "icon-chevron-left" "icon--inline" }}
                    {{ i18n "Back" }}</a
                >
            {{ end }}
        </p>

        {{ if ne (len .SuccessMessage) 0 }}
            <div class="alert--success">
                <p class="alert__title">{{ i18n "Success" }}</p>
                <p class="alert__content">{{ .SuccessMessage }}</p>
            </div>
        {{ end }}

        {{ if ne (len .ErrorMessages) 0 }}
            {{ block "errors" . }}
            {{ end }}
        {{ end }}


        <form
            hx-boost="true"
            hx-swap="outerHTML show:window:top"
            {{ if .Form.Name }}
                action="/services/{{ .Form.Name }}/publish"
            {{ else }}
                action="/services/publish"
            {{ end }}
            method="post"
            autocomplete="off"
            class="publish-service-page__form"
            hx-disabled-elt="button[type=submit]"
        >
            <input
                type="hidden"
                name="csrfToken"
                value="{{ .BaseAuthenticatedPage.CsrfToken }}"
            />
            <datalist id="peerIDs">
                {{ range $peerID, $peer := .DirectoryPeerIDs }}
                    <option value="{{ $peerID }}" label="{{ $peer }}"></option>
                {{ end }}
            </datalist>

            <datalist id="service-names">
                {{ range $serviceName := .ServiceNamesForPeer }}
                    <option value="{{ $serviceName }}">
                        {{ $serviceName }}
                    </option>
                {{ end }}
            </datalist>

            <fieldset class="publish-service-page__form-actions">
                <button type="submit" class="button--primary">
                    {{ i18n "Publish" }}
                </button>
            </fieldset>

            <fieldset>
                <label>
                    <span>{{ i18n "Name" }}</span>
                    {{ if .Form.Name }}
                        <input
                            class="input--large"
                            type="text"
                            name="name"
                            value="{{ .Form.Name }}"
                            disabled
                        />
                    {{ else }}
                        <div class="datalist datalist--medium">
                            <input
                                list="service-names"
                                name="name"
                                value="{{ .Form.Name }}"
                            />
                        </div>
                    {{ end }}
                </label>

                <label>
                    <span>{{ i18n "Directory Peer ID" }}</span>
                    <small
                        >{{ i18n "Peer ID of the Directory where you want to publish the Service." }}</small
                    >
                    <div class="datalist datalist--medium">
                        <input
                            list="peerIDs"
                            name="directoryPeerID"
                            value="{{ .Form.DirectoryPeerID }}"
                        />
                    </div>
                </label>

                <label>
                    <span>{{ i18n "Delegator Peer ID" }}</span>
                    <small
                        >{{ i18n "Peer ID of the Delegator in case your publishing this Service on behalf of another Peer." }}</small
                    >
                    <div class="datalist datalist--medium">
                        <input
                            list="peerIDs"
                            name="delegatorPeerID"
                            value="{{ .Form.DelegatorPeerID }}"
                        />
                    </div>
                </label>

                <div class="publish-service-page__date-field-wrapper">
                    <label class="publish-service-page__date-field">
                        {{ i18n "Valid from" }}
                        <input
                            class="input--small"
                            type="date"
                            name="validFrom"
                            value="{{ .Form.ValidFrom }}"
                            placeholder="{{ i18n " yyyy-mm-dd" }}"
                        />
                    </label>

                    <label class="publish-service-page__date-field">
                        {{ i18n "Valid until" }}
                        <input
                            class="input--small"
                            type="date"
                            name="validUntil"
                            value="{{ .Form.ValidUntil }}"
                            placeholder="{{ i18n " yyyy-mm-dd" }}"
                        />
                    </label>
                </div>
            </fieldset>
        </form>
    </div>
{{ end }}
